#include "hmg.ch"

Function Main
*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

*----------------------------------* 
  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  
*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
*-----------------------------------------------------------------*
 
   DEFINE WINDOW Form_1           ;
      AT 0,0                      ;
      WIDTH 800                   ;
      HEIGHT 610                  ;
      TITLE "Demo Grid CheckBox " ;
      NOSIZE NOMAXIMIZE           ;
      MAIN                        ;
      ON INIT Opentables() 

     @ 15,320 LABEL Label_1 Value "Select Products"  Width  440  Height 032     ; 
                    FONT "Arial" SIZE 17 BOLD ITALIC        

      fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , RED ) }
      bcolor := { || if ( This.CellRowIndex/2 = int (This.CellRowIndex/2) , {180,200,255} , {255,255,211} ) }   
         
*------------------------------- Color Barra Video Inversa ------------------------*

  _HMG_SYSDATA [ 348 ] := { 199,250,225 }    
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }   
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }  
   
*----------------------------------------------------------------------------------*

        SELECT 1
        USE STOCK INDEX STOCK

   DEFINE GRID Grid_1
      ROW     050
      COL     050
      WIDTH   700
      HEIGHT  197 
      HEADERS { '','Ref','Producto','Tipo' ,  'Precio'  ,  'C_Barras' }
      WIDTHS  { 17, 122 , 149 , 135 , 116 , 138 }
      VALUE 0  
      IMAGE   { '02.bmp','01.bmp' }
      JUSTIFY { GRID_JTFY_LEFT, GRID_JTFY_RIGHT, GRID_JTFY_LEFT , GRID_JTFY_LEFT, GRID_JTFY_RIGHT, GRID_JTFY_LEFT} 
      DYNAMICFORECOLOR { fColor , fColor, fColor , fColor, fColor, fColor } 
      DYNAMICBACKCOLOR { bColor , bColor, bColor , bColor, bColor, bColor }  
      BACKCOLOR { 209,238,238 }
      FONTCOLOR { 000,255,020 } 
      ONCHANGE SelecDes()
      MULTISELECT .F.
      ROWSOURCE "STOCK"
      COLUMNFIELDS { 'IIF(STOCK->L,1,0)', 'STOCK->REF','STOCK->PRODUCTO','STOCK->TIPO','STOCK->PRECIO','STOCK->CBARRAS' }
      FONTNAME 'Arial'
      FONTSIZE 9
      CELLNAVIGATION .T.
  END GRID

     @ 265,320 LABEL Label_2 Value "Product Selection " Width  440  Height 032 ; 
                     FONT "Arial" SIZE 17 BOLD ITALIC 
             
        SELECT 2   
        USE STOCKP 
        dbgobottom() 

   DEFINE GRID Grid_2
      ROW     305
      COL     050
      WIDTH   700
      HEIGHT  175 
      HEADERS { 'Ref','Producto','Tipo' ,'Precio','C_Barras' }
      WIDTHS  {139, 149, 135, 116, 140}
      ITEMS {{""}}
      VALUE 1  
      ROWSOURCE "STOCKP"
      COLUMNFIELDS { 'STOCKP->REF','STOCKP->PRODUCTO','STOCKP->TIPO','STOCKP->PRECIO','STOCKP->CBARRAS' }
      FONTNAME 'Arial'
      FONTSIZE 9
      JUSTIFY { GRID_JTFY_RIGHT , GRID_JTFY_LEFT, GRID_JTFY_LEFT, GRID_JTFY_RIGHT , GRID_JTFY_LEFT}  
      DYNAMICFORECOLOR { fColor, fColor , fColor, fColor, fColor }  
      DYNAMICBACKCOLOR { bColor, bColor , bColor, bColor, bColor }  
      BACKCOLOR { 209,238,238 } 
      FONTCOLOR { 000,255,020 }
   END GRID

      @ 515, 200 BUTTON Button_2  CAPTION "Delete Base" ACTION Deleter()
      @ 515, 365 BUTTON Button_3  CAPTION "Check List"  ACTION GetListSelect()   
      @ 515, 580 BUTTON Button_4  CAPTION "Exit" ACTION Form_1.Release

   END WINDOW

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

Return

*---------------------------------------------*
Function Opentables()
*---------------------------------------------*
        CLOSE DATABASES
        SELECT 1 
        USE STOCK
        DELETE FOR REF := 0
        PACK
        CLOSE DATABASES

        SELECT 1 
        USE STOCK NEW
        INDEX ON STR(REF) TO STOCK
        CLOSE DATABASES

        SELECT 1 
        USE STOCK INDEX STOCK
       
	SELECT 2   
        USE STOCKP
	Muy_Listo()
        Form_1.Grid_1.Refresh

Return

*.............................................*
Function SelecDes()
*---------------------------------------------*
  
STOCK->(DbGoTo( Form_1.Grid_1.RecNo))

If STOCK->L = .T.
	Replace STOCK->L With .F.
Else
	Replace STOCK->L With .T.
EndIf

Return

*------------------------------------------------*
FUNCTION Muy_Listo()
*------------------------------------------------*      
       SELECT 1 
       USE STOCK 
       DO WHILE .NOT. EOF()
            REPLACE L WITH .F.
            SKIP + 1
       ENDDO
    Form_1.Grid_1.Refresh
Return
*---------------------------------------------*
Function  GetListSelect() 
*---------------------------------------------*
        CLOSE DATABASES
        USE STOCKP
        APPEND FROM STOCK FIELDS Ref , Producto , Tipo , Precio , CBarras , L FOR L <> .F.  

        CLOSE DATABASES    
        SELECT 1 
        USE STOCK 
        DO WHILE .NOT. EOF()
            REPLACE L WITH .F.
            SKIP + 1
       ENDDO

        SELECT 1 
        USE STOCK INDEX STOCK

        SELECT 2   
        USE STOCKP
 
     Form_1.Grid_2.Refresh
     Muy_Listo()
     Form_1.Grid_1.Refresh
Return

*---------------------------------------------*
Function Deleter()
*---------------------------------------------*

    CLOSE DATABASES
    SELECT 2
    USE STOCKP
 IF STOCKP->REF == 0
    MsgInfo('No hay Datos para Borrar','Info Delete')
    Muy_Listo()
    Form_1.Grid_1.Refresh
    Form_1.Grid_2.Refresh
    Return
 ENDIF

    CLOSE DATABASES
    SELECT 2
    USE STOCKP
    ZAP

   SELECT 1 
   USE STOCK  INDEX STOCK

   Muy_Listo()
   Form_1.Grid_1.Refresh
   Form_1.Grid_2.Refresh

Return

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
